lists:flatten([],[]).
lists:flatten([X|Xs],L) :-
	lists_flatten(X,T,L),
	lists_flatten(Xs,[],T).

lists_flatten(X,T,L) :-
	( X == [] ->
	    L = T
	; (nonvar(X), X = [Y|Ys]) ->
	    lists_flatten(Y,T2,L),
	    lists_flatten(Ys,T,T2)
	;
	    L = [X|T]
	).
